#!/bin/bash

export PROC_COUNT=$(getconf _NPROCESSORS_ONLN)
export FFMPEG_VERSION=6.1.1
export CODEC_HEADERS_VERSION=12.1.14.0
export CUDA_VERSION=12.4
export INSTALL_PATH=$HOME/repo

p="export PATH=/usr/local/cuda-$CUDA_VERSION/bin:/usr/local/cuda:/usr/local/cuda-$CUDA_VERSION/nvvm/bin:/usr/local/cuda/bin:${PATH:+:${PATH}}" f="$HOME/.bashrc"; grep -q "${p}" "${f}" || echo "${p}" >>"${f}" && \
p="export LD_LIBRARY_PATH=/usr/local/cuda-$CUDA_VERSION/lib64:/usr/local/cuda-$CUDA_VERSION/targets/x86_64-linux/lib:/usr/local/lib:/opt/boost:${LD_LIBRARY_PATH:+:${LD_LIBRARY_PATH}}" f="$HOME/.bashrc"; grep -q "${p}" "${f}" || echo "${p}" >>"${f}" && \
p='export DISPLAY=:0' f="$HOME/.bashrc"; grep -q "${p}" "${f}" || echo "${p}" >>"${f}" && \
p='xhost +si:localuser:root' f="$HOME/.bashrc"; grep -q "${p}" "${f}" || echo "${p}" >>"${f}" && \
rm -rf $INSTALL_PATH/ip_platform/install/direct/nv-codec-headers-n$CODEC_HEADERS_VERSION && \
rm -rf $INSTALL_PATH/ip_platform/install/direct/n$CODEC_HEADERS_VERSION.tar.gz* && \
mkdir -p $INSTALL_PATH/ip_platform/install/direct && \
cd $INSTALL_PATH/ip_platform/install/direct && \
wget https://github.com/FFmpeg/nv-codec-headers/archive/n$CODEC_HEADERS_VERSION.tar.gz && \
tar zxf n$CODEC_HEADERS_VERSION.tar.gz && \
cd $INSTALL_PATH/ip_platform/install/direct/nv-codec-headers-n$CODEC_HEADERS_VERSION && \
sudo make install && \
sudo apt-get install -y cmake build-essential libc6 libc6-dev unzip libnuma1 libnuma-dev wget yasm autoconf automake cmake ninja-build curl bzip2 clang g++ gcc git gperf libtool make nasm perl pkg-config python3 yasm zlib1g-dev libexpat1-dev lsb-release libglew-dev libfreeimage-dev libtbb-dev libopenal-dev libxcursor-dev libxinerama-dev libxi-dev libsfml-dev libxrandr-dev libudev-dev libglu1-mesa-dev libharfbuzz0b libpangoft2-1.0-0 libcairo2 libv4l-0 libraw1394-11 libavc1394-0 libiec61883-0 libxtst6 libnss3 libnspr4 libgconf-2-4 libasound2 libopus-dev libgsm1-dev libmodplug-dev libvpx-dev libass-dev libbluray-dev libfribidi-dev libgmp-dev libgnutls28-dev libmp3lame-dev libopencore-amrnb-dev libopencore-amrwb-dev librtmp-dev libtheora-dev libx264-dev libxvidcore-dev libx265-dev libxss1 libgtk2.0-0 libatspi2.0-dev libatk-bridge2.0-dev libopenjp2-7-dev libopenmpt-dev libshine-dev libsnappy-dev libsoxr-dev libspeex-dev libtwolame-dev libvo-amrwbenc-dev libwavpack-dev libsdl2-dev libwebp-dev libunistring-dev libaom-dev libdav1d-dev libfdk-aac-dev libzimg-dev libvidstab-dev git htop nvtop && \
rm -rf $INSTALL_PATH/ip_platform/install/direct/SVT-AV1 && \
cd $INSTALL_PATH/ip_platform/install/direct && \
git clone https://gitlab.com/AOMediaCodec/SVT-AV1.git && \
mkdir -p SVT-AV1/build && cd SVT-AV1/build && \
cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE=Release -DBUILD_DEC=OFF -DBUILD_SHARED_LIBS=OFF .. && \
make -j $PROC_COUNT && \
sudo make install && \
rm -rf $INSTALL_PATH/ip_platform/install/direct/FFmpeg-n$FFMPEG_VERSION && \
rm -rf $INSTALL_PATH/ip_platform/install/direct/n$FFMPEG_VERSION.tar.gz* && \
cd $INSTALL_PATH/ip_platform/install/direct && \
wget https://github.com/FFmpeg/FFmpeg/archive/n$FFMPEG_VERSION.tar.gz && \
tar zxf n$FFMPEG_VERSION.tar.gz && \
cd $INSTALL_PATH/ip_platform/install/direct/FFmpeg-n$FFMPEG_VERSION && \
echo -e "include ld.so.conf.d/*.conf\n/usr/local/lib" | sudo tee     > /dev/null && \
sudo ldconfig && \
source $HOME/.bashrc && \
export PATH=/usr/local/cuda-$CUDA_VERSION/bin:/usr/local/cuda:/usr/local/cuda-$CUDA_VERSION/nvvm/bin:/usr/local/cuda/bin:${PATH:+:${PATH}} && \
export LD_LIBRARY_PATH=/usr/local/cuda-$CUDA_VERSION/lib64:/usr/local/cuda-$CUDA_VERSION/targets/x86_64-linux/lib:/usr/local/lib:/opt/boost:${LD_LIBRARY_PATH:+:${LD_LIBRARY_PATH}} && \
./configure --extra-cflags=-I/usr/local/cuda/include --extra-ldflags=-L/usr/local/cuda/lib64 --extra-libs='-lpthread -lm' --ld=g++ --enable-version3 --enable-sdl2 --enable-fontconfig --enable-libbluray --enable-libopencore-amrnb --enable-libopencore-amrwb --enable-libopenjpeg --enable-libshine --enable-libsnappy --enable-libsoxr --enable-libtheora --enable-libtwolame --enable-libwebp --enable-libxml2 --enable-zlib --enable-gmp --enable-libvo-amrwbenc --enable-libspeex --enable-libxvid --enable-libopenmpt --enable-gpl --enable-gnutls --enable-libaom --enable-libass --enable-libfdk-aac --enable-libfreetype --enable-libmp3lame --enable-libopus --enable-libsvtav1 --enable-libdav1d --enable-libvorbis --enable-libvpx --enable-libx264 --enable-libx265 --enable-nonfree --enable-cuda-nvcc --enable-libnpp --enable-libzimg --enable-libvidstab --disable-static --enable-shared --prefix=/usr/local && make -j $PROC_COUNT && sudo make install && \
sudo apt-get install -y libboost-all-dev && \
rm -rf $INSTALL_PATH/ip_platform/casparcg-server/build && \
mkdir -p $INSTALL_PATH/ip_platform/casparcg-server/build && \
cd $INSTALL_PATH/ip_platform/casparcg-server/build && \
cmake ../src -DENABLE_HTML=OFF -DUSE_SYSTEM_FFMPEG=ON -DUSE_STATIC_BOOST=ON && \
make -j $PROC_COUNT
